Codeforces 535C Tavas and Karafs(二分)

题意  有一个等差数列  从A开始  公差为B  然后n个询问  每个询问给定l,t,m   然后要求如果每次可以最多选择m个数
  使这m个数-1   那么在t次操作中可以使l为左端点的最长序列中使所有数为0  输出这个最长序列的右端序号

定理  序列h1,h2,...,hn 可以在t次时间内(每次至多让m个元素减少1)  全部减小为0  当且仅当

max(h1, h2, ..., hn) <= t  &&  h1 + h2 + ... + hn <= m*t   

那么就可以二分右端点来解决了  下限为l  上限为hi不超过t的最大i

#include <bits/stdc++.h>
typedef long long LL;
LL a, b, n, l, t, m;

LL getv(LL p)
{
    return a + (p - 1) * b;
}

LL getsum(LL r)
{
    return (getv(r) + getv(l)) * (r - l + 1) / 2;
}

int main()
{
    scanf("%lld%lld%lld", &a, &b, &n);
    while(n--)
    {
        scanf("%lld%lld%lld", &l, &t, &m);
        if(getv(l) > t) puts("-1");
        else
        {
            LL le = l, ri = (t - a) / b + 1, mid;
            while(le <= ri)
            {
                mid = (ri + le) / 2;
                if(getsum(mid) <= t * m) le = mid + 1;
                else ri = mid - 1;
            }
            printf("%lld\n", le - 1);
        }
    }
    return 0;
}

C. Tavas and Karafs

Karafs is some kind of vegetable in shape of an 1?×?h rectangle. Tavaspolis people love Karafs
and they use Karafs in almost any kind of food. Tavas, himself, is crazy about Karafs.

Each Karafs has a positive integer height. Tavas has an infinite 1-based sequence of Karafses. The height of the i-th
Karafs is si?=?A?+?(i?-?1)?×?B.

For a given m, let‘s define an m-bite operation
as decreasing the height of at most m distinct not eaten Karafses by 1. Karafs is considered as eaten when its height becomes zero.

Now SaDDas asks you n queries. In each query he gives you numbers lt and m and
you should find the largest number r such that l?≤?rand
sequence sl,?sl?+?1,?...,?sr can
be eaten by performing m-bite no more than t times or
print -1 if there is no such number r.

Input

The first line of input contains three integers AB and n (1?≤?A,?B?≤?106, 1?≤?n?≤?105).

Next n lines contain information about queries. i-th
line contains integers l,?t,?m (1?≤?l,?t,?m?≤?106)
for i-th query.

Output

For each query, print its answer in a single line.

Sample test(s)

input

2 1 4
1 5 3
3 3 10
7 10 2
6 4 8

output

4
-1
8
-1

input

1 5 2
1 5 10
2 7 4

output

1
2
时间: 2024-11-05 22:32:56

Codeforces 535C Tavas and Karafs(二分)的相关文章

CodeForces 535C Tavas and Karafs —— 二分

题意:给出一个无限长度的等差数列(递增),每次可以让从l开始的m个减少1,如果某个位置已经是0了,那么可以顺延到下一位减少1,这样的操作最多t次,问t次操作以后从l开始的最长0序列的最大右边界r是多少. 分析:由题意可以挖掘出两个条件:l~r中最大的值(因为是递增的,即r的值)必定不大于t:同时,t*m要大于或等于这一段的和.那么根据这两个条件进行二分即可. 细节:二分的右端点inf不能设置的太大,否则第一次的mid可能就会爆long long. 代码如下: 1 #include <stdio.

Codeforces 535C Tavas and Karafs

题目链接:CF - 535C Karafs is some kind of vegetable in shape of an 1 × h rectangle. Tavaspolis people love Karafs and they use Karafs in almost any kind of food. Tavas, himself, is crazy about Karafs. Each Karafs has a positive integer height. Tavas has

Codeforces 535C Tavas and Karafs 数学归纳

题意:给你一个等差数列.每一次选m个不同的数使得都减一,问你最多能承受t次的右端点是多少(左端点已给)要使得这个右端点最右. 解题思路:显然是二分,但是不知道如何判断.官方题解. 解题代码: 1 // File Name: c.cpp 2 // Author: darkdream 3 // Created Time: 2015年04月15日 星期三 01时04分48秒 4 5 #include<vector> 6 #include<list> 7 #include<map&g

Codeforces 536A Tavas and Karafs 二分+结论

题目链接:点击打开链接 题意:有一个等差数列,从A开始,公差为B 然后n个询问...每个询问给定l,t,m 然后要求如果每次可以最多选择m个数,使这m个数-1,那么在t次操作中可以使l为左端点的最长序列中使所有数为0 思路: 枚举答案判可行就好了. 有一个结论,就是只要最大的数<=t,那么一定存在某种方案使得:当和 <= t*m 时能把所有数消光. #include <stdio.h> #include <string.h> #include <string>

CF 535c Tavas and Karafs

Tavas and Karafs Time Limit:2000MS     Memory Limit:262144KB     64bit IO Format:%I64d & %I64u Submit Status Practice CodeForces 535C Description Karafs is some kind of vegetable in shape of an 1 × h rectangle. Tavaspolis people love Karafs and they

C. Tavas and Karafs 二分查找+贪心

C. Tavas and Karafs 1 #include <iostream> 2 #include <cstdio> 3 #include <cstring> 4 #include <cmath> 5 #include <algorithm> 6 #include <string> 7 #include <vector> 8 #include <set> 9 #include <map> 10

Codeforces Round #299 (Div. 2) Tavas and Karafs(二分)

英语渣渣感觉无力...翻了下题解才知道题意... 给你一个无限长的等差数列a,n个查询.对于每个查询,给出l,t,m,求最大的r.表示在等差数列a的第l号元素到第r号元素,执行t次操作,对于每一次操作,在[l,r]区间内选出m个数,并且把这m个数-1,执行完t次操作后,使得区间[l,r]内的数全部为0,求区间最大的右端点r. 如果t小于a[l],那么执行完t次操作a[l]也不会为0,输出-1 那么同理我们可以求出r的范围,r肯定小于等于(t-a)/b,因为数列是递增的. 既然我们都已经知道了范围

codeforces535C:Tavas and Karafs(二分)

Karafs is some kind of vegetable in shape of an 1?×?h rectangle. Tavaspolis people love Karafs and they use Karafs in almost any kind of food. Tavas, himself, is crazy about Karafs. Each Karafs has a positive integer height. Tavas has an infinite 1-b

Tavas and Karafs 二分+结论

二分比较容易想到 #include<map> #include<set> #include<cmath> #include<queue> #include<stack> #include<vector> #include<cstdio> #include<cassert> #include<iomanip> #include<cstdlib> #include<cstring>